using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace com.superscene.ui {
	class SupRelayCommand : ICommand {
		private Action _action;
		public SupRelayCommand(Action action) {
			_action = action;
		}

		public bool CanExecute(object parameter) {
			return true;
		}

		public event EventHandler CanExecuteChanged {
			add { CommandManager.RequerySuggested += value; }
			remove { CommandManager.RequerySuggested -= value; }
		}

		public void Execute(object parameter) {
			if(_action != null) {
				_action.Invoke();
			}
		}
	}

	class SupRelayCommand<T> : ICommand {
		private Action<T> _action;
		public SupRelayCommand(Action<T> action) {
			_action = action;
		}

		public bool CanExecute(object parameter) {
			return true;
		}

		public event EventHandler CanExecuteChanged {
			add { CommandManager.RequerySuggested += value; }
			remove { CommandManager.RequerySuggested -= value; }
		}

		public void Execute(object parameter) {
			if(_action != null) {
				_action.Invoke((T)parameter);
			}
		}
	}
}
